/** Data types that are transmitted via telecommands and telemetry. */
// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#pragma once

#include <stdint.h>
#include "generated/util.h"
#include "generated/units.h"

#ifdef __cplusplus
extern "C" {
#endif

/** The first byte of every message between the experiment and the ground station. */
#define SYNC_BYTE_1 170
/** The second byte of every message between the experiment and the ground station. */
#define SYNC_BYTE_2 85
/** Verification code to reset the chip. */
#define RESET_CHIP_VERIFICATION_CODE 23780
/** Verification code to set the flight state. */
#define SET_FLIGHT_VERIFICATION_CODE 36134
/** The number of registered configuration items. */
#define NUM_CONFIGURATIONS 35
/** The values of the default configuration. */
#define DEFAULT_CONFIGURATION {.parachuteTriggerAltitude = meter_t(5500.0), \
    .parachuteTriggerPressure = bar_t(0.458f), .altimeterMinPossibleValue = bar_t(0.0f), \
    .altimeterMaxPossibleValue = bar_t(120000.0f), .landedPressureMin = bar_t(0.7f), \
    .landedPressureMaxChange = bar_t(0.01f), .stablePressureLandedDuration = ms_t(1000), \
    .recoveryTelemetrySendPeriod = ms_t(10000), .recoveryTelemetryLandedSendPeriod = ms_t(10000), \
    .recoveryTelemetryStayingAliveSendPeriod = ms_t(600000), .stayAliveTriggerTime = ms_t(300000), \
    .parachuteDeployTriggerTime = ms_t(500000), \
    .requiredConsecutiveParachuteDeploySensorTime = ms_t(1000), \
    .GPSFailedInitWaitTime = ms_t(1000), .landedMaxAttitude = meter_t(1000.0), \
    .landedMaxAttitudeChange = meter_t(10.0), .stableAttitudeLandedDuration = ms_t(1000), \
    .detumbleControllerP = 300, .detumbleControllerI = 0, .detumbleControllerD = 0, \
    .orientationControllerP = 10, .orientationControllerI = 0, .orientationControllerD = 100, \
    .useMotorSpeedsForController = false, .heartbeatPeriod = ms_t(1000), \
    .preLaunchIMUCalibrationTime = ms_t(5000), .preLaunchMotorWarmupStartTime = ms_t(10000), \
    .preLaunchMotorWarmupEndTime = ms_t(20000), .minADCSBatteryLevel = volt_t(10.5), \
    .GoProOffTime = ms_t(3000), .GoProOnTime = ms_t(500), .ejectADCSStartWaitTime = ms_t(1000), \
    .IMUStatusCheckInterval = ms_t(500), .SDCardCheckInterval = ms_t(5000), \
    .initialTelemetryDelay = ms_t(50)}
/** The maximum size in bytes of a telecommand data payload. */
#define MAX_TELECOMMAND_DATA_SIZE 9
/** The maximum size in bytes of a telecommand response payload. */
#define MAX_TELECOMMAND_RESPONSE_SIZE 8


/** Ids of all possible configuration items. */
typedef enum {
    /**
     * The altitude in meters as determined by GPS below which the parachute should get deployed.
     */
    PARACHUTE_TRIGGER_ALTITUDE = 0,
    /** The pressure in bar below which the parachute should get deployed. */
    PARACHUTE_TRIGGER_PRESSURE = 1,
    /** If the pressure sensor reports values below this, it will be considered broken. */
    ALTIMETER_MIN_POSSIBLE_VALUE = 2,
    /** If the pressure sensor reports values above this, it will be considered broken. */
    ALTIMETER_MAX_POSSIBLE_VALUE = 3,
    /** The pressure in bar above which the FFU can be considered to be landed. */
    LANDED_PRESSURE_MIN = 4,
    /**
     * The maximum change in pressure between measurements for which the FFU is allowed to be
     * considered landed.
     */
    LANDED_PRESSURE_MAX_CHANGE = 5,
    /**
     * The duration in milliseconds for which the pressure has to be stable,
     * in order for the FFU to be considered landed.
     */
    STABLE_PRESSURE_LANDED_DURATION = 6,
    /** The period in milliseconds at which the recovery telemetry is going to be send. */
    RECOVERY_TELEMETRY_SEND_PERIOD = 7,
    /**
     * The period in milliseconds at which the recovery telemetry is going to be send once the FFU
     * landed.
     */
    RECOVERY_TELEMETRY_LANDED_SEND_PERIOD = 8,
    /**
     * The period in milliseconds at which the telemetry is going to be send once the recovery
     * system is in "staying alive" mode.
     */
    RECOVERY_TELEMETRY_STAYING_ALIVE_SEND_PERIOD = 9,
    /** The time in milliseconds after landing when to switch to "staying alive" mode. */
    STAY_ALIVE_TRIGGER_TIME = 10,
    /**
     * Time in milliseconds after ejection when to trigger the parachute deployment,
     * if it wasn't triggered before.
     */
    PARACHUTE_DEPLOY_TRIGGER_TIME = 11,
    /**
     * The time in milliseconds of consecutive altimeter or GPS readings below the threshold that
     * must be made in order to trigger the parachute deployment.
     */
    REQUIRED_CONSECUTIVE_PARACHUTE_DEPLOY_SENSOR_TIME = 12,
    /** The time in milliseconds to wait to retry a failed GPS initialization. */
    GPS_FAILED_INIT_WAIT_TIME = 13,
    /** The attitude in meters given by GPS below which the FFU can be considered to be landed. */
    LANDED_MAX_ATTITUDE = 14,
    /**
     * The maximum change in attitude read by GPS below which the FFU is allowed to be considered
     * landed.
     */
    LANDED_MAX_ATTITUDE_CHANGE = 15,
    /**
     * The duration in milliseconds for which the attitude read by GBS has to be stable,
     * in order for the FFU to be considered landed.
     */
    STABLE_ATTITUDE_LANDED_DURATION = 16,
    /** The proportional gain of the detumble controller. */
    DETUMBLE_CONTROLLER_P = 17,
    /** The integral gain of the detumble controller. */
    DETUMBLE_CONTROLLER_I = 18,
    /** The derivative gain of the detumble controller. */
    DETUMBLE_CONTROLLER_D = 19,
    /** The proportional gain of the orientation controller. */
    ORIENTATION_CONTROLLER_P = 20,
    /** The integral gain of the orientation controller. */
    ORIENTATION_CONTROLLER_I = 21,
    /** The derivative gain of the orientation controller. */
    ORIENTATION_CONTROLLER_D = 22,
    /** Whether to use the motor speeds in the controllers. */
    USE_MOTOR_SPEEDS_FOR_CONTROLLER = 23,
    /** How much time should pass between heartbeat messages in milliseconds. */
    HEARTBEAT_PERIOD = 24,
    /** The time in milliseconds after pre launch start when the IMU calibration should happen. */
    PRE_LAUNCH_IMU_CALIBRATION_TIME = 25,
    /**
     * The time in milliseconds after pre launch start when the motor warmup sequence should be
     * started.
     */
    PRE_LAUNCH_MOTOR_WARMUP_START_TIME = 26,
    /**
     * The time in milliseconds after pre launch start when the motor warmup sequence should end.
     */
    PRE_LAUNCH_MOTOR_WARMUP_END_TIME = 27,
    /** The minimum battery level for which the ADCS is allowed to run. */
    MIN_ADCS_BATTERY_LEVEL = 28,
    /** The time in milliseconds for the pulse on the GoPro pin to turn the GoPros off. */
    GOPRO_OFF_TIME = 29,
    /** The time in milliseconds for the pulse on the GoPro pin to turn the GoPros on. */
    GOPRO_ON_TIME = 30,
    /**
     * The time in milliseconds to wait after ejection is detected to enable the ADCS controller.
     */
    EJECT_ADCS_START_WAIT_TIME = 31,
    /** The interval in which the status of the IMUs is checked. */
    IMU_STATUS_CHECK_INTERVAL = 32,
    /** The time between successive checks of the SD-Cards in milliseconds. */
    SD_CARD_CHECK_INTERVAL = 33,
    /** An initial delay to wait after boot before generating telemetry. */
    INITIAL_TELEMETRY_DELAY = 34,

    CONFIGURATION_ID_FIRST MAYBE_UNUSED = PARACHUTE_TRIGGER_ALTITUDE,
    CONFIGURATION_ID_LAST MAYBE_UNUSED = INITIAL_TELEMETRY_DELAY,
} ConfigurationId;

/** The configuration of the secondary device. */
typedef struct PACKED {
    /**
     * The altitude in meters as determined by GPS below which the parachute should get deployed.
     */
    meter_t parachuteTriggerAltitude;
    /** The pressure in bar below which the parachute should get deployed. */
    bar_t parachuteTriggerPressure;
    /** If the pressure sensor reports values below this, it will be considered broken. */
    bar_t altimeterMinPossibleValue;
    /** If the pressure sensor reports values above this, it will be considered broken. */
    bar_t altimeterMaxPossibleValue;
    /** The pressure in bar above which the FFU can be considered to be landed. */
    bar_t landedPressureMin;
    /**
     * The maximum change in pressure between measurements for which the FFU is allowed to be
     * considered landed.
     */
    bar_t landedPressureMaxChange;
    /**
     * The duration in milliseconds for which the pressure has to be stable,
     * in order for the FFU to be considered landed.
     */
    ms_t stablePressureLandedDuration;
    /** The period in milliseconds at which the recovery telemetry is going to be send. */
    ms_t recoveryTelemetrySendPeriod;
    /**
     * The period in milliseconds at which the recovery telemetry is going to be send once the FFU
     * landed.
     */
    ms_t recoveryTelemetryLandedSendPeriod;
    /**
     * The period in milliseconds at which the telemetry is going to be send once the recovery
     * system is in "staying alive" mode.
     */
    ms_t recoveryTelemetryStayingAliveSendPeriod;
    /** The time in milliseconds after landing when to switch to "staying alive" mode. */
    ms_t stayAliveTriggerTime;
    /**
     * Time in milliseconds after ejection when to trigger the parachute deployment,
     * if it wasn't triggered before.
     */
    ms_t parachuteDeployTriggerTime;
    /**
     * The time in milliseconds of consecutive altimeter or GPS readings below the threshold that
     * must be made in order to trigger the parachute deployment.
     */
    ms_t requiredConsecutiveParachuteDeploySensorTime;
    /** The time in milliseconds to wait to retry a failed GPS initialization. */
    ms_t GPSFailedInitWaitTime;
    /** The attitude in meters given by GPS below which the FFU can be considered to be landed. */
    meter_t landedMaxAttitude;
    /**
     * The maximum change in attitude read by GPS below which the FFU is allowed to be considered
     * landed.
     */
    meter_t landedMaxAttitudeChange;
    /**
     * The duration in milliseconds for which the attitude read by GBS has to be stable,
     * in order for the FFU to be considered landed.
     */
    ms_t stableAttitudeLandedDuration;
    /** The proportional gain of the detumble controller. */
    int16_t detumbleControllerP;
    /** The integral gain of the detumble controller. */
    int16_t detumbleControllerI;
    /** The derivative gain of the detumble controller. */
    int16_t detumbleControllerD;
    /** The proportional gain of the orientation controller. */
    int16_t orientationControllerP;
    /** The integral gain of the orientation controller. */
    int16_t orientationControllerI;
    /** The derivative gain of the orientation controller. */
    int16_t orientationControllerD;
    /** Whether to use the motor speeds in the controllers. */
    bool useMotorSpeedsForController;
    /** How much time should pass between heartbeat messages in milliseconds. */
    ms_t heartbeatPeriod;
    /** The time in milliseconds after pre launch start when the IMU calibration should happen. */
    ms_t preLaunchIMUCalibrationTime;
    /**
     * The time in milliseconds after pre launch start when the motor warmup sequence should be
     * started.
     */
    ms_t preLaunchMotorWarmupStartTime;
    /**
     * The time in milliseconds after pre launch start when the motor warmup sequence should end.
     */
    ms_t preLaunchMotorWarmupEndTime;
    /** The minimum battery level for which the ADCS is allowed to run. */
    volt_t minADCSBatteryLevel;
    /** The time in milliseconds for the pulse on the GoPro pin to turn the GoPros off. */
    ms_t GoProOffTime;
    /** The time in milliseconds for the pulse on the GoPro pin to turn the GoPros on. */
    ms_t GoProOnTime;
    /**
     * The time in milliseconds to wait after ejection is detected to enable the ADCS controller.
     */
    ms_t ejectADCSStartWaitTime;
    /** The interval in which the status of the IMUs is checked. */
    ms_t IMUStatusCheckInterval;
    /** The time between successive checks of the SD-Cards in milliseconds. */
    ms_t SDCardCheckInterval;
    /** An initial delay to wait after boot before generating telemetry. */
    ms_t initialTelemetryDelay;
} Configuration;

/** Ids of all possible telecommands. */
typedef enum {
    /** Set the last state that is saved in flash memory. */
    COMMAND_SET_LAST_STATE = 0,
    /** Get the last state that is saved in flash memory. */
    COMMAND_GET_LAST_STATE = 1,
    /** Close the current log file and switch to a new one. */
    COMMAND_NEW_LOG_FILE = 2,
    /** Initiate a reset of the board. */
    COMMAND_RESET_CHIP = 3,
    /** Set the current state of the system state machine. */
    COMMAND_SET_CURRENT_STATE = 4,
    /** Get the current state of the system state machine. */
    COMMAND_GET_CURRENT_STATE = 5,
    /** Enable the condition allow ejection of the flight unit from the rocket. */
    COMMAND_SET_FLIGHT = 6,
    /** Get the flight condition state */
    COMMAND_GET_FLIGHT = 7,
    /** Set the pre launch timer. */
    COMMAND_SET_PRE_LAUNCH_TIMER = 8,
    /** Enable or disable the GoPros. */
    COMMAND_SET_VIDEO_ENABLED = 9,
    /** Reset the state of the recovery thread. */
    COMMAND_RESET_RECOVERY = 10,
    /** Enable or disable all reaction wheel motors. */
    COMMAND_MOTOR_ENABLED = 11,
    /** Enable or disable the motor warmup sequence. */
    COMMAND_MOTOR_WARMUP = 12,
    /** Set a configuration parameter. */
    COMMAND_SET_CONFIG = 13,
    /** Request the value of a configuration item from the experiment. */
    COMMAND_GET_CONFIG = 14,
    /** Set the pwm signal that should be send if the ADCS is in "MODE_PWM_DEBUG". */
    COMMAND_SET_PWM = 15,
    /** Set the rpm signal that should be send if the ADCS is in "MODE_RPM_DEBUG". */
    COMMAND_SET_RPM = 16,
    /** Set the mode of the ADC system. */
    COMMAND_SET_ADCS_MODE = 17,
    /** Deploy the parachute. This bypasses all software checks! Use with care! */
    COMMAND_DEPLOY_PARACHUTE = 18,
    /** Send a predefined test message trough the Iridium network. */
    COMMAND_SEND_IRIDIUM_MESSAGE = 19,
    /** Initiate calibration of one of the IMUs. */
    COMMAND_CALIBRATE_IMU = 20,
    /** Enable or disable the video recording by the payload. */
    COMMAND_SET_PAYLOAD_VIDEO = 21,
    /** Set the state of the recovery thread. */
    COMMAND_SET_RECOVERY_STATE = 22,

    TELECOMMAND_FIRST MAYBE_UNUSED = COMMAND_SET_LAST_STATE,
    TELECOMMAND_LAST MAYBE_UNUSED = COMMAND_SET_RECOVERY_STATE,
} Telecommand;

/** All possible types of telemetry messages. */
typedef enum {
    /** A periodic heartbeat to indicate that the system is still running. */
    TELEMETRY_HEARTBEAT = 0,
    /** A response to a telecommand with the response data. */
    TELEMETRY_RESPONSE = 1,
    /** Acknowledge receiving a command. */
    TELEMETRY_ACKNOWLEDGE = 2,
    /** A text message. */
    TELEMETRY_MESSAGE = 3,
    /** The first part of the telemetry of the system. */
    TELEMETRY_DATA1 = 4,
    /** The second part of the telemetry of the system. */
    TELEMETRY_DATA2 = 5,
    /** The third part of the telemetry of the system. */
    TELEMETRY_DATA3 = 6,
    /** The motor speed telemetry. */
    TELEMETRY_DATA_MOTOR_SPEEDS = 7,
    /** The rotation speed telemetry. */
    TELEMETRY_DATA_ROTATION_SPEEDS = 8,
    /** The set points telemetry. */
    TELEMETRY_DATA_SET_POINTS = 9,
    /** The data generated by the recovery thread once in the RECOVERY state. */
    TELEMETRY_DATA_RECOVERY = 10,

    TELEMETRY_TYPE_FIRST MAYBE_UNUSED = TELEMETRY_HEARTBEAT,
    TELEMETRY_TYPE_LAST MAYBE_UNUSED = TELEMETRY_DATA_RECOVERY,
} TelemetryType;

/** The header of a message for the ground station. */
typedef struct PACKED {
    /** The first synchronisation byte. */
    uint8_t syncByte1;
    /** The second synchronisation byte. */
    uint8_t syncByte2;
    /**
     * The checksum of the message.
     * The two sync bytes and the checksum are not included in the checksum,
     * but the telemetry data is included.
     */
    uint16_t checksum;
    /** The type of telemetry that is send in this message. */
    TYPED_ENUM(TelemetryType, uint8_t) type;
} TelemetryMessageHeader;

/** A quaternion representing a direction in space. */
typedef struct PACKED {
    double x;
    double y;
    double z;
    double w;
} Quaternion;

/** Possible states of the system. */
typedef enum {
    /** The system is inactive and waiting for a new command. */
    STATE_IDLE = 0,
    /** The system is awaiting the launch. */
    STATE_PRE_LAUNCH = 1,
    /** The system is in the launch state and reacting to signals from the rocket. */
    STATE_LAUNCH = 2,
    /** The system is free falling performing the experiment. */
    STATE_EXPERIMENT = 3,
    /** The system is inactive and transmitting location updates. */
    STATE_RECOVERY = 4,
    /** The system is inactive and the payload is shut off. */
    STATE_PAYLOAD_OFF = 5,
    /** The system is in a testing state. */
    STATE_TESTING = 6,

    SYSTEM_STATE_FIRST MAYBE_UNUSED = STATE_IDLE,
    SYSTEM_STATE_LAST MAYBE_UNUSED = STATE_TESTING,
} SystemState;

/** State of the recovery subsystem. */
typedef enum {
    /** The system is in startup and waiting for ejection. */
    RECOVERY_START = 0,
    /** The system is in flight and is waiting to trigger the parachutes. */
    RECOVERY_FLIGHT = 1,
    /** The system has triggered the parachutes. */
    RECOVERY_COMMANDED = 2,
    /** The system is descending with the parachutes. */
    RECOVERY_DESCENDING = 3,
    /** The system has landed on the ground. */
    RECOVERY_LANDED = 4,
    /** The system is reducing activity to save battery. */
    RECOVERY_STAYING_ALIVE = 5,

    RECOVERY_STATE_FIRST MAYBE_UNUSED = RECOVERY_START,
    RECOVERY_STATE_LAST MAYBE_UNUSED = RECOVERY_STAYING_ALIVE,
} RecoveryState;

/** A type of a telemetry message. */
typedef enum {
    /** A verbose message that will only be sent if the testing pin is set. */
    DEBUG_MESSAGE = 0,
    /** An informational message. */
    INFO_MESSAGE = 1,
    /** A message indicating an error or failure. */
    ERROR_MESSAGE = 2,
    /** A message indicating a critical error or failure. */
    CRITICAL_ERROR_MESSAGE = 3,

    MESSAGE_TYPE_FIRST MAYBE_UNUSED = DEBUG_MESSAGE,
    MESSAGE_TYPE_LAST MAYBE_UNUSED = CRITICAL_ERROR_MESSAGE,
} MessageType;

/** The modes the ADCS can run in. */
typedef enum {
    /** The ADCS system is off. The motors are not commanded. */
    MODE_OFF = 0,
    /** The system tries to spin up the motors according to a predefined spin up sequence. */
    MODE_SPIN_UP = 1,
    /** The system tries to spin the motors to warm them up. */
    MODE_WARM_UP = 2,
    /** The system tries to reach a zero rotation state. */
    MODE_STABILITY = 3,
    /** The system tries to orient itself to a given target orientation. */
    MODE_ORIENTATION = 4,
    /**
     * The ADCS commands a fixed pwm signal to the motors.
     * @see setDebugPWM
     */
    MODE_PWM_DEBUG = 5,
    /** The ADCS commands a fixed rpm value to the motors. */
    MODE_RPM_DEBUG = 6,
    /** The ADCS commands a looping testing sequence to the motors. */
    MODE_SEQ_DEBUG = 7,

    ADCS_MODE_FIRST MAYBE_UNUSED = MODE_OFF,
    ADCS_MODE_LAST MAYBE_UNUSED = MODE_SEQ_DEBUG,
} AdcsMode;

/** A three dimensional vector with 32 bit numbers. */
typedef struct PACKED {
    int32_t roll;
    int32_t pitch;
    int32_t yaw;
} Vec3Int32;

/** A three dimensional vector with a timestamp. */
typedef struct PACKED {
    ms_t time;
    Vec3Int32 data;
} Vec3Int32WithTime;

/** A three dimensional vector with floating point numbers. */
typedef struct PACKED {
    float roll;
    float pitch;
    float yaw;
} Vec3F;

/** A three dimensional vector with a timestamp. */
typedef struct PACKED {
    ms_t time;
    Vec3F data;
} Vec3FWithTime;

/** A telecommand send from the ground station. */
typedef struct PACKED {
    /** A number identifying this command. */
    uint8_t counter;
    /** The type of telecommand. */
    TYPED_ENUM(Telecommand, uint8_t) command;
    /** The argument data for this command. */
    uint8_t data[MAX_TELECOMMAND_DATA_SIZE];
} TelecommandData;

/** A message from the ground station. */
typedef struct PACKED {
    /** The first synchronisation byte. */
    uint8_t syncByte1;
    /** The second synchronisation byte. */
    uint8_t syncByte2;
    /** The telecommand that is send with this message. */
    TelecommandData telecommand;
    /**
     * The checksum of the message.
     * The two sync bytes and the checksum itself are not included in the checksum.
     */
    uint16_t checksum;
} GroundStationMessage;


#ifdef __cplusplus
}
#endif
